#!/usr/bin/perl

use threads;
use LWP::UserAgent;
use strict;

use constant PORT      => 8080;
use constant TEAMINIP  => 1;  # nets: 1 = 10.X.0 || 2 = 10.0.X
use constant PASSLEN   => 7;
use constant SENDCOUNT => 2;

my $ua = LWP::UserAgent->new;
$ua->agent("Opera/9.64 ");
$ua->timeout(7);

#=========================================================================
sub gethost {
	$_ = shift;
	return 'http://' .$_. ':' .PORT. '/';
	}
#=========================================================================
sub generatelogin {
	$_ = shift;
	my @ip = split /\./;
	my ($s,$m,$h,$d,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	my $t = $ip[TEAMINIP];
	if ($t < 10) { $t = '0' .$t; }
	if ($s < 10) { $s = '0' .$s; }
	if ($m < 10) { $m = '0' .$m; }
	if ($h < 10) { $h = '0' .$h; }
	my $login = 'u' .$t. $d . $h . $m . $s;
	print STDERR "Generated login: " .$login. "\n";
	return $login;
	}
#=========================================================================
sub generatepass {
	my $login = shift;

	srand(substr($login, 1));
	my @abc = ('0'..'9','A'..'Z','a'..'z','-','_');
	my $pass = "";
	for (1..PASSLEN) {
		$pass .= $abc[rand($#abc)];
		}
	print STDERR "Generated password: " .$pass."\n";
	return $pass;
	}
#=========================================================================
sub urlencode {
	$_ = shift;
	s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
	return $_;
	}
#=========================================================================
sub register {
	my ($host, $login) = @_;

	my $crc = int(rand(900000)) + 100000;
	my $code = int(($crc * 100 - 1) / 900);
	print STDERR "Register(login = ".$login."  crc = ".$crc."  code = ".$code.")\n";
	my $pass = generatepass($login);
	my $req = HTTP::Request->new(POST => $host. 'reg.php');
	$req->content_type('application/x-www-form-urlencoded');
	$req->header(Referer => $host);
	my $other = 'PASS1='.$pass.'&PASS2='.$pass.'&EMAIL=noemail%40mail.ru&ADMIN=1';
	$req->content('CRC=' .$crc. '&CODE=' .$code. '&LOGIN='.$login.'&'.$other);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while registering new account";
		#print STDERR $res->content;
		exit(4);
		}
	if ($res->content !~ /regform/) {
		print STDOUT "Registration failed";
		#print STDERR $res->content;
		exit(3);
		}
	return ($pass, $code);
	}
#=========================================================================
sub login {
	my ($host, $login, $pass) = @_;

	print STDERR "Login(login = ".$login."  pass = ".$pass.")\n";
	my $req = HTTP::Request->new(POST => $host. "login.php");
	$req->content_type('application/x-www-form-urlencoded');
	$req->header(Referer => $host);
	$req->content('USER=' .$login. '&PASS=' .$pass);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while logging in";
		exit(4);
		}
	if ($res->content !~ /loginpanel/i) {
		print STDOUT "Login failed";
		#print STDERR $res->content;
		exit(3);
		}
	return $res->header("Set-Cookie");
	}
#=========================================================================
sub postprivate {
	my ($host, $cookies, $msg) = @_;

	print STDERR "PostPrivate(host = ".$host.")\n";
	my $req = HTTP::Request->new(POST => $host. "messages.php");
	$req->content_type('application/x-www-form-urlencoded');
	$req->header(Referer => $host);
	$req->header(Cookie => $cookies);
	$req->content('MSG=' .urlencode($msg));
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while sending a private msg";
		exit(4);
		}
	if ($res->content !~ /msgsent/i) {
		print STDOUT "Send Private Msg Failed";
		#print STDERR $res->content;
		exit(3);
		}	
	}
#=========================================================================
sub getprivate {
	my ($host, $cookies) = @_;

	print STDERR "GetPrivate(host = ".$host.")\n";
	my $getstr = $host. "messages.php";
	my $req = HTTP::Request->new(GET => $getstr);
	$req->header(Referer => $host);
	$req->header(Cookie => $cookies);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while getting private msg";
	    exit(4);
	    }
	return $res->content;
	}
#=========================================================================
sub logout {
	my ($host, $login, $cookies) = @_;

	print STDERR "Logout(login = ".$login.")\n";
	my $req = HTTP::Request->new(POST => $host. "login.php");
	$req->content_type('application/x-www-form-urlencoded');
	$req->header(Referer => $host);
	$req->header(Cookie => $cookies);
	$req->content('USER=' .$login. '&LOGOUT=1');
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while logging out";
		exit(4);
		}
	elsif ($res->content !~ /loginpanel/i) {
		print STDOUT "Logout failed";
		exit(3);
		}
	else {
		print STDERR "Registration, Login, Send, Logout OK\n";
		}
	}
#=========================================================================
sub viewmap {
	my $host = shift;

	print STDERR "ViewMap(host = ".$host.")\n";
	my $req = HTTP::Request->new(GET => $host. "stations.php");
	$req->header(Referer => $host);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while getting the map";
		exit(4);
		}
	elsif ($res->content !~ /stations/i) {
		print STDOUT "Stations are not found";
		exit(3);
		}
	else {
		my @lines = split(/\<form\s+id\=\"stfrm\"/si, $res->content);
		@lines = split(/\<\/table\>\s*\<\/form\>/si, $lines[1]);
		@lines = split(/\n/, $lines[0]);
		my @friends = ();
		for(@lines) {
			if (m/\<tr[^\>]+station\"?\>\<td[^\>]*\>(\d+)\<\/td\>.+\<font[^\>]+\=\"?connected\"?\>/i) {
				#print STDERR "found " .$1. "\n"; 
				push(@friends, $1);
				}
			}
		return @friends;
		}
	}
#=========================================================================
sub checkfriend {
	my ($number, $me, $last) = @_;

	my $host;
	if (TEAMINIP == 1) { $host = gethost("10." .$number. ".0." .$last); }
	elsif (TEAMINIP == 2) { $host = gethost("10.0." .$number. "." .$last); }
	else { print STDERR "Wrond TEAMINIP = " .TEAMINIP; }
	my $req = HTTP::Request->new(GET => $host. "stations.php");
	$req->header(Referer => $host);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		return 0;	# No route to friend
		}
	elsif ($res->content !~ /stations/i) {
		return 1;	# Friend-cheater
		}
	else {
		return ($res->content =~ /\<tr[^\>]+station\"?\>\<td[^\>]*\>$me\<\/td\>.+\<font[^\>]+\=\"?connected\"?\>/si) ? 1 : 0;
		}
	}
#=========================================================================
sub checkfriends {
	my ($ip, $friends) = @_;
	my @friends = @$friends;
	print STDERR "CheckFriends(ip = ".$ip;
	print STDERR "  friends = " .(scalar @friends). "(" .join(",",@friends). "))\n";
	if (@friends <= 0) { return; }
	my @ip = split(/\./, $ip);
	my %thrs = ();
	for(@friends) {
		$thrs{$_} = threads->create("checkfriend", $_, $ip[1], $ip[3]);
		}
    for ( keys %thrs ) {
		my $result = $thrs{$_}->join();
		if ($result == 0) {
			print STDOUT "Checking friendship with team '" .$_. "' failed";
			exit(3);
			}
		}
	}
#=========================================================================
sub sendfast {
	my ($number, $login, $parts, $code, $last) = @_;
	
	print STDERR "SendFAST(number = ".$number."  parts = " .$parts. ")\n";
	my $host;
	if (TEAMINIP == 1) { $host = gethost("10." .$number. ".0." .$last); }
	elsif (TEAMINIP == 2) { $host = gethost("10.0." .$number. "." .$last); }
	else { print STDERR "Wrond TEAMINIP = " .TEAMINIP; }
	my $getstr = "?team=" .substr($login,1,2). "&time=" .substr($login,3);
	$getstr   .= "&parts=" .$parts. "&code=" .$code;
	my $req = HTTP::Request->new(GET => $host. "receipt.php".$getstr);
	$req->header(Referer => $host);
	$ua->request($req);
	}
#=========================================================================
sub sendpass {
	my ($ip, $login, $pass, $friends) = @_;
	my @friends = @$friends;
	print STDERR "SendPass(ip = ".$ip;
	print STDERR "  friends = " .(scalar @friends). "(" .join(",",@friends). "))\n";
	if (@friends <= 0) { return; }
	my (%send, %codes) = ();
	for(@friends) { $send{$_} = ""; $codes{$_} = ""; }
	
	my @pas = split(//, $pass);
	if (@friends > PASSLEN) {
		for my $k (1..SENDCOUNT) {
			my $i = $k-1;
			for(@friends) {
				$send{$_}   = ($send{$_} eq "")? $i : ($send{$_}.",".$i);
				$codes{$_} .= $pas[$i];
				if (++$i >= PASSLEN) { $i = 0; }
				}
			}
		}
	else {
		my $i = 0;
		while ($i < PASSLEN) {
			for(@friends) {
				$send{$_}   = ($send{$_} eq "")? $i : ($send{$_}.",".$i);
				$codes{$_} .= $pas[$i];
				if (++$i >= PASSLEN) { last; }
				}
			}
		}
	
	my $last = (split(/\./, $ip))[3];

	my @thr = ();
	for (@friends) {
		push(@thr, threads->create("sendfast",$_,$login,$send{$_},$codes{$_},$last));
		}
	for (@thr) {
		$_->join();
		}
	}
#=========================================================================
sub checkchat {
	my ($host, $login, $cookies) = @_;
	
	print STDERR "CheckChat(login = ".$login.")\n";
	my @msgs = ("Hello all!", "How are you?", "Bye-bye!",
				"Nice to meet you!", "Have a nice day!", "Hi guys!");

	my $req = HTTP::Request->new(POST => $host. "chatframe.php");
	$req->content_type('application/x-www-form-urlencoded');
	$req->header(Referer => $host);
	$req->header(Cookie => $cookies);
	my $msg = $msgs[rand($#msgs)];
	$req->content('MSG=' .urlencode($msg));
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while sending chat msg";
		exit(4);
		}
	if ($res->content !~ /$login/) {
		print STDOUT "Send Chat Msg Failed";
		exit(3);
		}
	}
#=========================================================================
sub checkreceipt {
	my ($host, $login, $pass) = @_;
	
	print STDERR "CheckReceipt(login = ".$login.")\n";
	srand(time);
	my ($r1, $r2) = (int(rand(3)), int(rand(3))+3);
	my $getstr = "?type=exchange&team=" .substr($login,1,2);
	$getstr   .= "&time=".substr($login,3)."&parts=".$r1.",".$r2;
	$getstr	  .= "&code=".substr($pass,$r1,1).substr($pass,$r2,1);
	my $req = HTTP::Request->new(GET => $host. "receipt.php".$getstr);
	$req->header(Referer => $host);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while exchanging receipts";
		exit(4);
		}
	my @lines = split(/\n/,$res->content);
	my $newlogin = 'u' .$lines[0]. $lines[1];
	my $newpass = generatepass($newlogin);
	my @parts = split(/\,/, $lines[2]);
	my $checkedpass = "";
	for(@parts) {
		$checkedpass .= substr($newpass, $_, 1);
		}
	if ($lines[3] != $checkedpass) {
		print STDOUT "Exchange with receipts failed";
		#print STDERR $res->content;
		exit(3);
		}	
	}
#=========================================================================
sub checkbanner {
	my ($ip, $host) = @_;
	
	print STDERR "CheckBanner(ip = ".$ip.")\n";
	my $req = HTTP::Request->new(GET => $host. "index.php");
	$req->header(Referer => $host);
	my $res = $ua->request($req);
	if (not $res->is_success) {
		print STDOUT "Service didn't respond while checking banner";
		exit(4);
		}
	if ($res->content !~ /\<embed\s+src\=\"http\:\/\/$ip\:316\/\"/si){
		print STDOUT "Banner check failed";
		#print STDERR $res->content;
		exit(3);
		}	
	}
#=========================================================================
sub check {
	my $ip = shift;

	print STDERR "CHECK(ip = ".$ip.")\n";
	my $host = gethost($ip);
	my $login = generatelogin($ip);
	my $msg  = "%D0%9A%D0%B0%D0%BA+%D0%B6%D0%B8%D0%B7%D0%BD%D1%8C%3F";
	
	checkbanner($ip, $host);
	my ($pass, $code) = register($host, $login);
	my $cookies = login($host, $login, $pass);
	postprivate($host, $cookies, $msg);
	checkchat($host, $login, $cookies);
	logout($host, $login, $cookies);
	checkreceipt($host, $login, $pass);
	my @friends = viewmap($host);
	if (@friends < 1) {
		print STDOUT "No friends. Useless station";
		sleep 1;
		exit(3);
		}
	checkfriends($ip, \@friends);
	print STDERR "Additional checks OK";
	sleep 1;
	exit(1);
	}
#=========================================================================
sub put {
	my ($ip, $id, $flag) = @_;

	print STDERR "==PUT(ip = ".$ip.")\n";
	my $host = gethost($ip);
	my $login = generatelogin($ip);
	
	my ($pass, $code) = register($host, $login);
	my $cookies = login($host, $login, $pass);
	postprivate($host, $cookies, $flag);
	logout($host, $login, $cookies);
	my @friends = viewmap($host);
	if (@friends > 0) {
		sendpass($ip, $login, $pass, \@friends);
		}
	else {
		print STDERR "No friends, but skip\n";
		}
	print STDOUT substr($login, 1);  # there is a new ID
	sleep 1;
	exit(1);
	}
#=========================================================================
sub get {
	my ($ip, $id, $flag) = @_;

	print STDERR "==GET(ip = ".$ip.")\n";
	my $host = gethost($ip);
	my $login = 'u' .$id;
	
	my $pass = generatepass($login);
	my $cookies = login($host, $login, $pass);
	my $found = getprivate($host, $cookies);
	logout($host, $login, $cookies);
	if (index($found, $flag) < 0) {
		print STDOUT "Flag not found";
		exit(2);
		}
	print STDERR "Flag found";
	exit(1);
	}
#=========================================================================
my $action = shift @ARGV;

if ($action eq "put") {
	put(@ARGV);
	}
elsif ($action eq "get") {
	get(@ARGV);
	}
elsif ($action eq "check") {
	check(@ARGV);
	}
else {
	print STDOUT "Unknown action (arg 1). Wait for 'check', 'get', 'put'";
	exit(10);
	}
